#ifndef _UFS_FS_H
#define _UFS_FS_H

#include <linux/fs.h>

extern struct inode_operations ufs_file_inode_operations;
extern struct inode_operations ufs_dir_inode_operations;
extern struct inode_operations ufs_symlink_inode_operations;

extern int ufs_lookup(struct inode * dir,const char * name, int len,
        	      struct inode ** result);
extern int ufs_readdir(struct inode *inode, struct file *filp,
		       void* dirent, filldir_t filldir);
extern struct super_block *ufs_read_super(struct super_block *s,void *data,
				          int silent);
extern void ufs_read_inode(struct inode *inode);
extern struct buffer_head *ufs_getblk(struct inode *inode, int bn);
extern struct buffer_head *ufs_bread(struct inode *inode, int bn);
extern daddr_t ufs_blknum(struct inode *inode, int bn);

#endif
