#ifndef _UFS_FS_SB_H
#define _UFS_FS_SB_H

#include <linux/types.h>

/*
 * extract of struct ufs_super_block, defined at ufs_fs.h.
 */
struct ufs_sb_info {
	char	fs_convert;		/* flag whether byte ordering requires conversion */
	long	fs_block_base;		/* translation ufs block -> Linux block */
	daddr_t	fs_sblkno;		/* addr of super-block in filesys */
	daddr_t	fs_cblkno;		/* offset of cyl-block in filesys */
	daddr_t	fs_iblkno;		/* offset of inode-blocks in filesys */
	daddr_t	fs_dblkno;		/* offset of first data after cg */
	long	fs_cgoffset;		/* cylinder group offset in cylinder */
	long	fs_cgmask;		/* used to calc mod fs_ntrak */
	long	fs_size;		/* number of blocks in fs */
	long	fs_dsize;		/* number of data blocks in fs */
	long	fs_ncg;			/* number of cylinder groups */
	long	fs_bsize;		/* size of basic blocks in fs */
	long	fs_fsize;		/* size of frag blocks in fs */
	long	fs_frag;		/* number of frags in a block in fs */
	long	fs_fsbtodb;		/* fsbtodb and dbtofsb shift constant */
	long	fs_cpg;			/* cylinders per group */
	long	fs_ipg;			/* inodes per group */
	long	fs_fpg;			/* blocks per group * fs_frag */
	long	fs_bshift;		/* ``lblkno'' calc of logical blkno */
	long	fs_fshift;		/* ``numfrags'' calc number of frags */
	long	fs_fragshift;		/* block to frag shift */
	long	fs_nindir;		/* value of NINDIR */
	long	fs_inopb;		/* value of INOPB */
	long	fs_nspf;		/* value of NSPF */
	long	fs_bmask;		/* ``blkoff'' calc of blk offsets */
	long	fs_fmask;		/* ``fragoff'' calc of frag offsets */
	long	fs_minfree;		/* minimum percentage of free blocks */
	struct buffer_head *s_sbh[2];	/* buffer of superblock */
	long	fs_cg_magic;		/* CG_MAGIC in proper endianness */
	long	fs_freebsd2;		/* 1 if d_namlen is split */
};

#endif
